/* **********************************************************************
*Copyright (C) 2002 Elliott Mitchell					*
*All rights reserved.							*
*									*
*$Id: libcolorset.h,v 3.2 2002/06/01 05:36:58 ehem Exp $			*
*************************************************************************
*CS410-Combinatorial Search Project					*
************************************************************************/

#ifndef __LIBCOLORSET_H__
#define __LIBCOLORSET_H__

#include <stdlib.h>
#include "types.h"
#include "common.h"

/*unfortunatly gcc does not allow arrays of bits so we've got to do this way*/
#define _BITARRYELSZ sizeof(long)
#ifdef __arch64__
#define _BITARRYBITS 64
#define _BITARRYSHFT 6
#define _BITARRYMASK 0x3F
#else
#define _BITARRYBITS 32
#define _BITARRYSHFT 5
#define _BITARRYMASK 0x1F
#endif

#define CS_NEW(targ) ((targ)=calloc(1, sizeof(struct colorset)-_BITARRYELSZ))

#define CS_SET(targ, bit) do { \
	if(((bit)>>_BITARRYSHFT)+1>(targ)->size) { \
		(targ)=realloc((targ), sizeof(struct colorset)+ \
((bit)>>_BITARRYSHFT)*_BITARRYELSZ); \
		(targ)->data[(bit)>>_BITARRYSHFT]=0; \
		(targ)->size=((bit)>>_BITARRYSHFT)+1; \
	} \
	(targ)->data[(bit)>>_BITARRYSHFT]|=1<<((bit)&_BITARRYMASK); \
} while(0)

#define CS_CLR(targ, bit) ((targ)->data[(bit)>>_BITARRYSHFT]&=~(1<<((bit)& \
_BITARRYMASK)))

#define CS_TST(targ, bit) ((bit)>>_BITARRYSHFT>(targ)->size?0:(targ)->data \
[(bit)>>_BITARRYSHFT]&1<<((bit)&_BITARRYMASK))

#define CS_CLEAR(targ) do {color_t i; for(i=0; i<(targ)->size; ++i) \
(targ)->data[i]=0;} while(0)

#define CS_DEL(targ) free(targ)

#endif

