/* *********************************************************************
*Copyright (C) 2002 Elliott Mitchell					*
*All rights reserved.							*
*									*
*$Id: main.c,v 3.4 2002/05/23 06:22:06 ehem Exp $			*
*************************************************************************
*CS410-Combinatorial Search Project					*
************************************************************************/


#include "common.h"


char buildstring[]=
"c Build Options: (when main was built, note selective rebuilds may void "
"this)\n"
"c\n"
#ifdef BITS16
"c BITS16 Node, Node Edge, and Color maximums are 65534\n"
#else
#ifdef BITS32
"c BITS32 Node, Node Edge, and Color maximums are 4294967294\n"
#else
#ifdef BITS64
"c BITS64 Node, Node Edge, and Color maximums are 18446744073709551614\n"
#endif
#endif
#endif
"c\n"
#ifdef MAXTOUCH
"c MAXTOUCH=##MAXSTR items will be examined\n"
#else
"c !MAXTOUCH default number of items will be examined (1000?)\n"
#endif
#ifdef TOUCHNODES
"c TOUCHNODES Node touches are counted\n"
#else
"c !TOUCHNODES Instances are counted\n"
#endif
"c\n"
#ifdef DEBUG
"c DEBUG Debugging is turned on\n"
#else
"c !DEBUG Debugging is turned off\n"
#endif
#ifdef REVERSE
"c REVERSE Nodes are sorted (and colored) in reverse order\n"
#else
"c !REVERSE Nodes are sorted (and colored) in normal order\n"
#endif
#ifdef ALTPENALTY
"c ALTPENALTY Only changing away will be a discrepancy (otherwise any change "
"is)\n"
#endif
"c\n"
;

static void trivialsolution(struct instance *);

int main(int argc, char **argv)
{
	struct instance *inst;

	fprintf(stdout, buildstring);

	inst=doinput(stdin);
	if(!inst->islands) { /*No islands; Hmm...*/
		trivialsolution(inst);
		return(0); /*shell true value*/
	}
	dumbcolor(inst);
/*	initrandom();*/
	search(inst);
	trivialcolor(inst);
	dooutput(stdout, inst);
	destroyinstance(inst);
	return(0); /*shell true value*/
}

void trivialsolution(struct instance *inst)
{
	edge_t ep=0;
	struct node *nodewk;

	if(!inst->nodecnt) { /*Hmm, Zero nodes, kind of easy*/
		fprintf(stdout, "c Trivial problem; empty set\n" "c\n"
"s %s %d\n" "b %d\n", "col", 0, 0);
		return;
	}

	nodewk=inst->workchain;

	while(nodewk->iptr) {
		if(nodewk->sptr) {
			if(nodewk->sptr->bestcolor==1) nodewk->bestcolor=2;
			else nodewk->bestcolor=1;
			ep=1;
		} else nodewk->bestcolor=1;
		nodewk=nodewk->iptr;
	}

	fprintf(stdout, "c Trivial problem %s edges\nc\n", ep?"with":"without");

	fprintf(stdout, "s %s %d\n" "b %d\n", "col", ep?1:2, ep?1:2);

	nodewk=inst->nodeptr;
	while(nodewk->id) {
		fprintf(stdout, "l %d %d\n", nodewk->id, nodewk->bestcolor);
		nodewk=(struct node *)(nodewk->edges+nodewk->ecnt);
	}
}

